#include <hmg.ch>

  
Function Main
   private aKeys := {}
   private aData := {}
   private nCount := 0
   private oHTML := nil
   private aIsHeaders := {}
   public cFontName := 'Arial'
   public nFontSize := 10
   public oDB
   public aColorTable := { 255, 255, 200 }
   public aColorProperties := { 200, 255, 200 }
   public aTabPages := {}
   public aBoldFont := ARRAY FONT cFontName SIZE nFontSize BOLD 
   public aFont := ARRAY FONT cFontName SIZE nFontSize 

   private nDesktopWidth := GetDesktopWidth()
   private nDesktopHeight := GetDesktopHeight() - 60
   set font to cFontName, nFontSize
   define window main at 0, 0 width nDesktopWidth height nDesktopHeight title 'Universal JSON Viewer 3.0' main nosize icon 'icon' on release cleantemp()
      define toolbar toolbar1 imagewidth 24 imageheight 24 flat .t. strictwidth .t.
         button open picture 'open' action selectjson() tooltip 'Open JSON File'
         button navigate1 picture 'edit' action navigatejson() tooltip 'Convert JSON Text' separator
         button close1 picture 'file_close' action clearjson() tooltip 'Close JSON'
         button export2  picture 'excel' action navigatehtmlstart() tooltip 'Export to Excel' 
         button export1  picture 'list' action exporttables() tooltip 'Export to Excel (Ref. Tables)' 
         button export3  picture 'xml' action exporttablesxml() tooltip 'Export to XML DATA TABLE' separator
         button about1 picture 'user' action about() tooltip 'About Universal JSON Viewer'
         button exit  picture 'exit' action main.release() tooltip 'Exit'
      end toolbar
      define button selectfile
         row 40
         col 10
         width 120
         caption 'Open JSON File'
         action selectjson()
      end button
      define button navigate
         row 40
         col 140
         width 120
         caption 'Convert JSON'
         action navigatejson()
      end button
      define button exportexcelnew
         row 40
         col 270
         width 200
         caption 'Export to Excel (Flattened)'
         action navigatehtmlstart()
      end button
      define button export
         row 40
         col 480
         width 200
         caption 'Export to Excel (Ref. Tables)'
         action exporttables()
      end button
      define button exportxml
         row 40
         col 690
         width 200
         caption 'Export to XML Data Table'
         action exporttablesxml()
      end button
      define button about
         row 40
         col 900
         width 100
         caption 'About'
         action about()
      end button
      define editbox jsontext
         row 70
         col 10
         width nDesktopWidth - 20
         height 150
         hscrollbar .f.
      end editbox
      define tab json at 230, 10 width nDesktopWidth - 20 height nDesktopHeight - 270
      end tab
//      on key escape action main.release
   end window      
   // page name, parentid, tabcount
//   aadd( aTabPages, { 'Root', 0, 1 } )
  Main.Activate
Return

function selectjson
   local aContent
   local cValue := ''
   local i := 0
   cFile := getfile( { { 'JSON Files (*.json)', '*.json' }, { 'All Files (*.*)', '*.*' } }, 'Open JSON File...' )
   if file( cFile )
      main.jsontext.value := memoread( cFile ) 
      main.json.release
      define tab json parent main at 230, 10 width nDesktopWidth - 20 height nDesktopHeight - 270 
      end tab
      asize( aTabPages, 0 )
      // try to navigate
      navigatejson()
   endif
   
function navigatejson   
   local aTable := {}
   local i := 0
   if hmg_len( alltrim( main.jsontext.value ) ) == 0
      return nil
   endif
   if file( GetTempFolder() + 'json_temp.sqlite' )
      ferase( GetTempFolder() + 'json_temp.sqlite' )
   endif   
   oDB := connect2db( GetTempFolder() + 'json_temp.sqlite', .t. )
   if oDB == nil
      msgstop( 'DB can not be created!' )
      return nil
   endif
   // create json table
   miscsql( oDB, 'drop TABLE if exists jsoncontent' )      
   miscsql( oDB, 'CREATE TABLE jsoncontent( key ANY, value ANY, type TEXT, atom ANY, id INTEGER, parent INTEGER, fullkey TEXT, path TEXT )' )      
   miscsql( oDB, "insert into jsoncontent select * from json_tree( '" + main.jsontext.value  + "' )" ) 
   main.json.release
   define tab json parent main at 230, 10 width nDesktopWidth - 20 height nDesktopHeight - 270 
   end tab
   asize( aTabPages, 0 )
   // get root!
   aTable := sql( oDB, 'select key, value, type, id, parent from jsoncontent where id = 0' )
   if hmg_len( aTable ) > 0
      if aTable[ 1, 3 ] == 'array'
         showtable( 0 )
      endif
      if aTable[ 1, 3 ] == 'object'
         showproperties( 0 )
      endif
   endif   
return nil

function showproperties( nParent )
   local aTable := {}
   local cWindowName := ''
   local cPath := ''
   local cKey := ''
   local cValue := ''
   local i := 0
   local nTabPage := 0
   local aLineData := {}
   local nChildKey := 0
   local cGridName := ''
   local cStatusName := ''
   local aHeaders := {} 
   local aJustify := {}
   local aWidths := {}
   local aDynamicColors := {}
   local aDynamicForeColors := {}
   local aRowParents := {}
   local cCol := ''
   for i := 1 to hmg_len( aTabPages )
      if aTabPages[ i, 2 ] == nParent
         nTabPage := aTabPages[ i, 3 ]
         main.json.value := nTabPage
         return nil
      endif
   next i
   aTable := sql( oDB, 'select key, value, type, id, parent, path from jsoncontent where parent = ' +c2sql( nParent ) )
   if hmg_len( aTable ) > 0
      cPath := aTable[ 1, 6 ]
      aadd( aHeaders, 'Parent Ref.' )
      aadd( aJustify, 1 )
      aadd( aLineData, any2str( aTable[ 1, 5 ] ) )
      for i := 1 to hmg_len( aTable )
         cHeader := aTable[ i, 1 ]
         nJustify := 0
         do case
         case aTable[ i, 3 ] == 'null'
            cValue := 'null'
            cKey := aTable[ i, 1 ]
         case aTable[ i, 3 ] == 'array'   
            cValue := any2str( aTable[ i, 4 ] )
            cHeader := '#[' + cHeader + ']'
            nJustify := 1
         case aTable[ i, 3 ] == 'object'      
            cValue := any2str( aTable[ i, 4 ] )
            cHeader := '#{' + cHeader + '}'
            nJustify := 1
         case aTable[ i, 3 ] == 'integer' .or. aTable[ i, 3 ] == 'real'
            cValue := any2str( aTable[ i, 2 ] )
            nJustify := 1
         otherwise 
            cValue := any2str( aTable[ i, 2 ] )
         endcase   
         aadd( aHeaders, cHeader )
         aadd( aJustify, nJustify )
         aadd( aLineData, cValue )
      next i
   endif   
   asize( aWidths, hmg_len( aHeaders ) )
   afill( aWidths, 100 )
   for i := 1 to hmg_len( aHeaders )
      do case
      case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#['
         aadd( aDynamicColors, { || aclone( aColorTable ) } )
      case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#{'
         aadd( aDynamicColors, { || aclone( aColorProperties ) } )
      otherwise
         aadd( aDynamicColors, { || { 255, 255, 255 } } )
      endcase
   next i
   nTabPage := hmg_len( aTabPages ) + 1
   aadd( aTabPages, { cPath, nParent, nTabPage } )
   cGridName := 'table' + alltrim( str( nTabPage ) )
   cStatusName := 'status' + alltrim( str( nTabPage ) )
   for i := 1 to hmg_len( aHeaders )
      aadd( aDynamicForeColors, { || if( getproperty( 'main', cGridName, 'CHECKBOXITEM', this.cellrowindex ), {255, 0, 0} , {0, 0, 0 } ) } )
   next i      
   define grid &cGridName
      parent main
      row 10
      col 10
      width nDesktopWidth - 40
      height nDesktopHeight - 350
      headers aHeaders
      dynamicbackcolor aDynamicColors
      dynamicforecolor aDynamicForeColors
      cellnavigation .t.
      onchange setproperty( 'main', cStatusName, 'VALUE', alltrim( str( this.value[ 1 ] ) ) + '/' + alltrim( str( this.itemcount ) ) )
      ondblclick tablecolselected()
      widths aWidths
      justify aJustify
      items { aLineData }
   end grid   
   define label &cStatusName
      parent main
      row 40 + ( nDesktopHeight - 350 ) 
      col 10
      width nDesktopWidth - 40
      fontbold .t.
      fontsize nFontSize + 2
      fontname cFontName
      value '1/1'
   end label
   setproperty( 'main', cGridName, 'CHECKBOXENABLED', .t. )
   main.json.addpage( nTabPage, cPath )
   main.json.addcontrol( cGridName, nTabPage, 40, 10 )
   main.json.addcontrol( cStatusName, nTabPage, 50 + ( nDesktopHeight - 350 ) , 10 )
   DoMethod( 'main', cGridName, 'DISABLEUPDATE' )
   for i := 1 to hmg_len( aHeaders )
      setproperty( 'main', cGridName, 'COLUMNDYNAMICFONT', i, { || if( getproperty( 'main', cGridName, 'CHECKBOXITEM', this.cellrowindex ),aBoldFont, nil ) } )
   next i         
   setproperty( 'main', cGridName, 'VALUE', { 1, 1 } )
   DoMethod( 'main', cGridName, 'ENABLEUPDATE' )
   for j := 1 to hmg_len( aHeaders )
      asize( aRowParents, 0 )
      cCol := aHeaders[ j ]
      do case
      case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#['
         for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
            cValue := getproperty( 'main', cGridName, 'CELL', i , j )
            aadd( aRowParents, cValue )
         next i   
         showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
      case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#{'
         for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
            cValue := getproperty( 'main', cGridName, 'CELL', i , j )
            aadd( aRowParents, cValue )
         next i   
         showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
      endcase
   next j      
   && for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
      && aLineData := getproperty( 'main', cGridName, 'ITEM', i )
      && nChildKey := val( alltrim( aLineData[ 1 ] ) )
      && do case
      && case hb_usubstr( aLineData[ 3 ], 1, 2 ) == '#['
         && showtable( nChildKey )
      && case hb_usubstr( aLineData[ 3 ], 1, 2 ) == '#{'
         && showproperties( nChildKey )
      && endcase
   && next i      

return nil

function showtable( nParent )
   local aTable := {}
   local aData := {}
   local aHeaders := {}
   local aLineData := {}
   local cWindowName := ''
   local aWidths := {} 
   local aJustify := {}
   local i, j, k 
   local aTable1 := {}
   local cPath := ''
   local cValue := ''
   local cKey := ''
   local cHeader := ''
   local aDynamicColors := {}
   local nTabPage := 0
   local nChildKey := 0
   local aRowParents := {}
   local nJustify := 0
   local aDynamicForeColors := {}
   local aDynamicFonts := {}
   local bFontCheck := { || if( getproperty( thiswindow.name, this.name, 'CHECKBOXITEM', this.cellrowindex ), aBoldFont, aFont ) }
   local cGridName := ''
   local cStatusName
   for i := 1 to hmg_len( aTabPages )
      if aTabPages[ i, 2 ] == nParent
         nTabPage := aTabPages[ i, 3 ]
         main.json.value := nTabPage
         return nil
      endif
   next i
   aTable1 := sql( oDB, 'select key, id, parent, path from jsoncontent where parent = ' + c2sql( nParent ) )
   nTotRows := hmg_len( aTable1 )
   if nTotRows > 0
      cPath := aTable1[ 1, 4 ]
      // no. of rows in the table
      for i := 1 to nTotRows 
         aTable := sql( oDB, 'select key, value, type, id  from jsoncontent where parent = ' + c2sql( aTable1[ i, 2 ] ) )
         if hmg_len( aTable ) > 0
            if i == 1
               aadd( aHeaders, 'Ref.' ) 
               aadd( aJustify, 1 )
               aadd( aHeaders, 'Parent Ref.' )
               aadd( aJustify, 1 )
               for j := 1 to hmg_len( aTable )
                  cHeader := aTable[ j, 1 ]
                  nJustify := 0
                  do case
                  case aTable[ j, 3 ] == 'array'   
                     cHeader := '#[' + cHeader + ']'
                     nJustify := 1
                  case aTable[ j, 3 ] == 'object'      
                     cHeader := '#{' + cHeader + '}'
                     nJustify := 1
                  case aTable[ j, 3 ] == 'integer' .or. aTable[ j, 3 ] == 'real'
                     nJustify := 1 
                  endcase
                  aadd( aHeaders, cHeader )
                  aadd( aJustify, nJustify )
               next j
            endif
            aLineData := {}
            asize( aLineData, hmg_len( aHeaders ) )
            afill( aLineData, '' )
            aLineData[ 1 ] := any2str( aTable1[ i, 2 ] ) 
            aLineData[ 2 ] := any2str( aTable1[ i, 3 ] ) 
            for j := 1 to hmg_len( aTable )
               cHeader := aTable[ j, 1 ]
               nJustify := 0
               do case
               case aTable[ j, 3 ] == 'array'   
                  cHeader := '#[' + cHeader + ']'
               case aTable[ j, 3 ] == 'object'      
                  cHeader := '#{' + cHeader + '}'
               case aTable[ j, 3 ] == 'integer' .or. aTable[ j, 3 ] == 'real'
                  nJustify := 1 
               endcase   
               if ascan( aHeaders, cHeader ) == 0 // header not found add null data for others!
                  aadd( aHeaders, cHeader )
                  aadd( aJustify, nJustify )
                  aadd( aLineData, '' ) // for current row!
                  for k := 1 to hmg_len( aData )
                     aadd( aData[ k ], '' )
                  next k
               endif
               nCol := ascan( aHeaders, cHeader )
               if nCol == 0 // still header not found! 
                  msgstop( 'Error!' )
                  return nil
               endif
               do case
               case aTable[ j, 3 ] == 'null'
                  cValue := 'null'
               case aTable[ j, 3 ] == 'array'   
                  cValue := any2str( aTable[ j, 4 ] ) 
               case aTable[ j, 3 ] == 'object'      
                  cValue := any2str( aTable[ j, 4 ] ) 
               otherwise 
                  cValue := any2str( aTable[ j, 2 ] )
               endcase   
               aLineData[ nCol ] := cValue 
            next j
            aadd( aData, aclone( aLineData ) )
         endif
      next i
      asize( aWidths, hmg_len( aHeaders ) )
      afill( aWidths, 100 )
      
      for i := 1 to hmg_len( aHeaders )
         do case
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#['
            aadd( aDynamicColors, { || aclone( aColorTable ) } )
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#{'
            aadd( aDynamicColors, { || aclone( aColorProperties ) } )
         otherwise
            aadd( aDynamicColors, { || { 255, 255, 255 } } )
         endcase
      next i
      nTabPage := hmg_len( aTabPages ) + 1
      aadd( aTabPages, { cPath, nParent, nTabPage } )
      cGridName := 'table' + alltrim( str( nTabPage ) )
      cStatusName := 'status' + alltrim( str( nTabPage ) )
      for i := 1 to hmg_len( aHeaders )
         aadd( aDynamicForeColors, { || if( getproperty( 'main', cGridName, 'CHECKBOXITEM', this.cellrowindex ), {255, 0, 0} , {0, 0, 0 } ) } )
      next i      
      define grid &cGridName
         parent main
         row 10
         col 10
         width nDesktopWidth - 40
         height nDesktopHeight - 350
         headers aHeaders
         justify aJustify
         cellnavigation .t.
         widths aWidths
         onchange setproperty( 'main', cStatusName, 'VALUE', alltrim( str( this.value[ 1 ] ) ) + '/' + alltrim( str( this.itemcount ) ) )
         ondblclick tablecolselected()
         dynamicforecolor aDynamicForeColors
         dynamicbackcolor aDynamicColors
         items aData
      end grid
      define label &cStatusName
         parent main
         row 40 + ( nDesktopHeight - 350 ) 
         col 10
         width nDesktopWidth - 40
         fontbold .t.
         fontsize nFontSize + 2
         fontname cFontName
         value '1/'+ alltrim( str( hmg_len( aData ) ) )
      end label
      setproperty( 'main', cGridName, 'CHECKBOXENABLED', .t. )
      main.json.addpage( nTabPage, cPath )
      main.json.addcontrol( cGridName, nTabPage, 40, 10 )
      main.json.addcontrol( cStatusName, nTabPage, 50 + ( nDesktopHeight - 350 ) , 10 )
      DoMethod( 'main', cGridName, 'DISABLEUPDATE' )
      for i := 1 to hmg_len( aHeaders )
         setproperty( 'main', cGridName, 'COLUMNDYNAMICFONT', i, { || if( getproperty( 'main', cGridName, 'CHECKBOXITEM', this.cellrowindex ),aBoldFont, nil ) } )
      next i         
      setproperty( 'main', cGridName, 'VALUE', { 1, 1 } )
      DoMethod( 'main', cGridName, 'ENABLEUPDATE' )
      for j := 1 to hmg_len( aHeaders )
         asize( aRowParents, 0 )
         cCol := aHeaders[ j ]
         do case
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#['
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#{'
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         endcase
      next j      
   endif
   return nil
   
function propertyselected()
   local cWindowName := thiswindow.name
   local cControlName := this.name
   local nValue := this.value
   local nParent := 0
   if nValue > 0
      aLineData := this.item( nValue )
      nParent := val( alltrim( aLineData[ 1 ] ) )
      do case
      case hb_usubstr( aLineData[ 3 ], 1, 2 ) == '#['
         showtable( nParent )
      case hb_usubstr( aLineData[ 3 ], 1, 2 ) == '#{'
         showproperties( nParent )
      endcase
   endif
return nil
   
   
function tablecolselected
   local aLineNo := this.value
   local cPath := thiswindow.title
   local nRow := 0
   local nCol := 0
   local cCol := ''
   local cValue := ''
   local aRowParents := {}
   local i := 0
   if hmg_len( aLineNo ) == 2
      nRow := aLineNo[ 1 ] 
      nCol := aLineNo[ 2 ]
   endif
   if nRow > 0 .and. nCol > 0
      cValue := this.cell( nRow, nCol )
      cCol := this.header( nCol )
      do case
      case hb_usubstr( cCol, 1, 2 ) == '#[' 
         for i := 1 to this.itemcount
            cValue := this.cell( i, nCol )
            aadd( aRowParents, cValue )
         next i   
         showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ), val( alltrim( this.cell( nRow, nCol ) ) ) )
      case hb_usubstr( cCol, 1, 2 ) == '#{' 
         for i := 1 to this.itemcount
            cValue := this.cell( i, nCol )
            aadd( aRowParents, cValue )
         next i   
         showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ), val( alltrim( this.cell( nRow, nCol ) ) ) )
      otherwise
         return nil
      endcase
   endif
return nil   

function showtablerows( aRowParents, cTitle, nParent, nCurParent )
   local aTable := {}
   local i,j,k := 0
   local aHeaders := {}
   local aWidths := {}
   local aJustify := {}
   local aData := {}
   local aLineData := {}
   local cPath := ''
   local nCol := 0
   local cValue := ''
   local cWindowName := ''
   local cHeader := ''
   local aDynamicColors := {}
   local nTabPage := 0
   local cGridName := ''
   local cStatusName := ''
   local nJustify := 0
   local aDynamicForeColors := {}
   default nCurParent := 0
   for i := 1 to hmg_len( aTabPages )
      if aTabPages[ i, 2 ] == nParent
         nTabPage := aTabPages[ i, 3 ]
         main.json.value := nTabPage
         if nCurParent > 0
            setproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'CHECKBOXENABLED', .t. )
            setproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'CHECKBOXALLITEMS', .F. )
            for j := 1 to getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEMCOUNT' )
               if val( alltrim( getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'CELL', j, 2 ) ) ) == nCurParent
                  setproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'CHECKBOXITEM', j, .T. )
               endif   
            next j      
         endif
         return nil
      endif
   next i
   if hmg_len( aRowParents ) > 0
      for l := 1 to hmg_len( aRowParents )
         nRowID := val( alltrim( aRowParents[ l ] ) )
         aTable1 := sql( oDB, 'select key, id, parent, path from jsoncontent where parent = ' + c2sql( nRowID ) )
         nTotRows := hmg_len( aTable1 )
         if nTotRows > 0   
         // no. of rows in the child table
            for i := 1 to nTotRows
               aTable := sql( oDB, 'select key, value, type, id  from jsoncontent where parent = ' + c2sql( aTable1[ i, 2 ] ) )
               if hmg_len( aTable ) > 0
                  if hmg_len( aData ) == 0 // first row
                     aadd( aHeaders, 'Ref.' ) 
                     aadd( aJustify, 1 )
                     aadd( aHeaders, 'Parent Ref.' )
                     aadd( aJustify, 1 )
                     for j := 1 to hmg_len( aTable )
                        cHeader := aTable[ j, 1 ]
                        nJustify := 0
                        do case
                        case aTable[ j, 3 ] == 'array'   
                           cHeader := '#[' + cHeader + ']'
                           nJustify := 1
                        case aTable[ j, 3 ] == 'object'      
                           cHeader := '#{' + cHeader + '}'
                           nJustify := 1
                        case aTable[ j, 3 ] == 'integer' .or. aTable[ j, 3 ] == 'real'
                           nJustify := 1
                        endcase   
                        aadd( aHeaders, cHeader )
                        aadd( aJustify, nJustify )
                     next j
                  endif
                  aLineData := {}
                  asize( aLineData, hmg_len( aHeaders ) )
                  afill( aLineData, '' )
                  aLineData[ 1 ] := any2str( aTable1[ i, 2 ] ) 
                  aLineData[ 2 ] := any2str( aTable1[ i, 3 ] ) 
                  for j := 1 to hmg_len( aTable )             
                     cHeader := aTable[ j, 1 ]
                     nJustify := 0
                     do case
                     case aTable[ j, 3 ] == 'array'   
                        cHeader := '#[' + cHeader + ']'
                        nJustify := 1
                     case aTable[ j, 3 ] == 'object'      
                        cHeader := '#{' + cHeader + '}'
                        nJustify := 1
                     case aTable[ j, 3 ] == 'integer' .or. aTable[ j, 3 ] == 'real'
                        nJustify := 1
                     endcase   
                     if ascan( aHeaders, cHeader ) == 0 // header not found add null data for others!
                        aadd( aHeaders, cHeader )
                        aadd( aJustify, nJustify )
                        aadd( aLineData, '' ) //for current row
                        for k := 1 to hmg_len( aData )
                           aadd( aData[ k ], '' )
                        next k
                     endif
                     nCol := ascan( aHeaders, cHeader )
                     if nCol == 0 // still header not found! 
                        msgstop( 'Error!' )
                        return nil
                     endif
                     do case
                     case aTable[ j, 3 ] == 'null'
                        cValue := 'null'
                     case aTable[ j, 3 ] == 'array'   
                        cValue := any2str( aTable[ j, 4 ] ) 
                     case aTable[ j, 3 ] == 'object'      
                        cValue := any2str( aTable[ j, 4 ] ) 
                     otherwise 
                        cValue := any2str( aTable[ j, 2 ] )
                     endcase   
                     aLineData[ nCol ] := cValue 
                  next j
                  aadd( aData, aclone( aLineData ) )
               endif
            next i
         endif   
      next l
      asize( aWidths, hmg_len( aHeaders ) )
      afill( aWidths, 100 )
      for i := 1 to hmg_len( aHeaders )
         do case
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#['
            aadd( aDynamicColors, { || aclone( aColorTable ) } )
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#{'
            aadd( aDynamicColors, { || aclone( aColorProperties ) } )
         otherwise
            aadd( aDynamicColors, { || { 255, 255, 255 } } )
         endcase
      next i
      nTabPage := hmg_len( aTabPages ) + 1
      aadd( aTabPages, { cTitle, nParent, nTabPage } )
      cGridName := 'table' + alltrim( str( nTabPage ) )
      cStatusName := 'status' + alltrim( str( nTabPage ) )
      for i := 1 to hmg_len( aHeaders )
         aadd( aDynamicForeColors, { || if( getproperty( 'main', cGridName, 'CHECKBOXITEM', this.cellrowindex ), {255, 0, 0} , {0, 0, 0 } ) } )
      next i
     define grid &cGridName
         parent main
         row 10
         col 10
         width nDesktopWidth - 40
         height nDesktopHeight - 350
         headers aHeaders
         justify aJustify
         cellnavigation .t.
         onchange setproperty( 'main', cStatusName, 'VALUE', alltrim( str( this.value[ 1 ] ) ) + '/' + alltrim( str( this.itemcount ) ) )
         dynamicbackcolor aDynamicColors
         dynamicforecolor aDynamicForeColors
         widths aWidths
         ondblclick tablecolselected()
         items aData
      end grid   
      define label &cStatusName
         parent main
         row 40 + ( nDesktopHeight - 350 ) 
         col 10
         width nDesktopWidth - 40
         fontbold .t.
         fontsize nFontSize + 2
         fontname cFontName
         value '1/'+ alltrim( str( hmg_len( aData ) ) )
      end label
      setproperty( 'main', cGridName, 'CHECKBOXENABLED', .t. )
      main.json.addpage( nTabPage, cTitle )
      main.json.addcontrol( cGridName, nTabPage, 40, 10 )
      main.json.addcontrol( cStatusName, nTabPage, 50 + ( nDesktopHeight - 350 ) , 10 )
      setproperty( 'main', cGridName, 'VALUE', { 1, 1 } )
      DoMethod( 'main', cGridName, 'DISABLEUPDATE' )
      for i := 1 to hmg_len( aHeaders )
         setproperty( 'main', cGridName, 'COLUMNDYNAMICFONT', i, { || if( getproperty( 'main', cGridName, 'CHECKBOXITEM', this.cellrowindex ),aBoldFont, nil ) } )
      next i         
      DoMethod( 'main', cGridName, 'ENABLEUPDATE' )
      for j := 1 to hmg_len( aHeaders )
         asize( aRowParents, 0 )
         cCol := aHeaders[ j ]
         do case
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#['
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#{'
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         endcase
      next j      
   endif      
   return nil
   
function showtableproperties( aRowParents, cTitle, nParent, nCurParent )   
   local aTable := {}
   local i,j,k := 0
   local aHeaders := {}
   local aWidths := {}
   local aJustify := {}
   local aData := {}
   local aLineData := {}
   local cPath := ''
   local nCol := 0
   local cValue := ''
   local cGridName := ''
   local cStatusName := ''
   local aDynamicColors := {}
   local nTabPage := 0
   local aDynamicForeColors := {}
   default nCurParent := 0
   for i := 1 to hmg_len( aTabPages )
      if aTabPages[ i, 2 ] == nParent
         nTabPage := aTabPages[ i, 3 ]
         main.json.value := nTabPage
         if nCurParent > 0
            setproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'CHECKBOXENABLED', .t. )
            setproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'CHECKBOXALLITEMS', .F. )
            for j := 1 to getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEMCOUNT' )
               if val( alltrim( getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'CELL', j, 1 ) ) ) == nCurParent
                  setproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'CHECKBOXITEM', j, .T. )
               endif   
            next j      
         endif
         return nil
      endif
   next i
   if hmg_len( aRowParents ) > 0
      for i := 1 to hmg_len( aRowParents )
         nRowID := val( alltrim( aRowParents[ i ] ) )
         aTable := sql( oDB, 'select key, value, type, id  from jsoncontent where parent = ' + c2sql( nRowId ) )
         if hmg_len( aTable ) > 0
            if hmg_len( aData ) == 0 // first row
               aadd( aHeaders, 'Parent Ref.' )
               aadd( aJustify, 1 )
               for j := 1 to hmg_len( aTable )
                  cHeader := aTable[ j, 1 ]
                  nJustify := 0
                  do case
                  case aTable[ j, 3 ] == 'array'   
                     cHeader := '#[' + cHeader + ']'
                     nJustify := 1
                  case aTable[ j, 3 ] == 'object'      
                     cHeader := '#{' + cHeader + '}'
                     nJustify := 1
                  case aTable[ j, 3 ] == 'integer' .or. aTable[ j, 3 ] == 'real'
                     nJustify := 1
                  endcase   
                  aadd( aHeaders, cHeader )
                  aadd( aJustify, nJustify )
               next j
            endif
            aLineData := {}
            asize( aLineData, hmg_len( aHeaders ) )
            afill( aLineData, '' )
            aLineData[ 1 ] := any2str( nRowID ) 
            for j := 1 to hmg_len( aTable )             
               nJustify := 0
               cHeader := aTable[ j, 1 ]
               do case
               case aTable[ j, 3 ] == 'array'   
                  cHeader := '#[' + cHeader + ']'
                  nJustify := 1
               case aTable[ j, 3 ] == 'object'      
                  cHeader := '#{' + cHeader + '}'
                  nJustify := 1
               case aTable[ j, 3 ] == 'integer' .or. aTable[ j, 3 ] == 'real'     
                  nJustify := 1
               endcase   
               if ascan( aHeaders, cHeader ) == 0 // header not found add null data for others!
                  aadd( aHeaders, cHeader )
                  aadd( aJustify, nJustify )
                  aadd( aLineData, '' ) //for current row
                  for k := 1 to hmg_len( aData )
                     aadd( aData[ k ], '' )
                  next k
               endif
               nCol := ascan( aHeaders, cHeader )
               if nCol == 0 // still header not found! 
                  msgstop( 'Error!' )
                  return nil
               endif
               do case
               case aTable[ j, 3 ] == 'null'
                  cValue := 'null'
               case aTable[ j, 3 ] == 'array'   
                  cValue := any2str( aTable[ j, 4 ] )
               case aTable[ j, 3 ] == 'object'      
                  cValue := any2str( aTable[ j, 4 ] )
               otherwise 
                  cValue := any2str( aTable[ j, 2 ] )
               endcase   
               aLineData[ nCol ] := cValue 
            next j
            aadd( aData, aclone( aLineData ) )
         endif
      next i
      asize( aWidths, hmg_len( aHeaders ) )
      afill( aWidths, 100 )
      for i := 1 to hmg_len( aHeaders )
         do case
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#['
            aadd( aDynamicColors, { || aclone( aColorTable ) } )
         case hb_usubstr( aHeaders[ i ], 1, 2 ) == '#{'
            aadd( aDynamicColors, { || aclone( aColorProperties ) } )
         otherwise
            aadd( aDynamicColors, { || { 255, 255, 255 } } )
         endcase
      next i
      nTabPage := hmg_len( aTabPages ) + 1
      aadd( aTabPages, { cTitle, nParent, nTabPage } )
      cGridName := 'table' + alltrim( str( nTabPage ) )
      cStatusName := 'status' + alltrim( str( nTabPage ) )
      for i := 1 to hmg_len( aHeaders )
         aadd( aDynamicForeColors, { || if( getproperty( 'main', cGridName, 'CHECKBOXITEM', this.cellrowindex ), {255, 0, 0} , {0, 0, 0 } ) } )
      next i
      define grid &cGridName
         parent main
         row 10
         col 10
         width nDesktopWidth - 40
         height nDesktopHeight - 350
         headers aHeaders
         justify aJustify
         cellnavigation .t.
         onchange setproperty( 'main', cStatusName, 'VALUE', alltrim( str( this.value[ 1 ] ) ) + '/' + alltrim( str( this.itemcount ) ) )
         dynamicbackcolor aDynamicColors
         dynamicforecolor aDynamicForeColors
         widths aWidths
         ondblclick tablecolselected()
         items aData
      end grid  
      define label &cStatusName
         parent main
         row 40 + ( nDesktopHeight - 350 ) 
         col 10
         width nDesktopWidth - 40
         fontbold .t.
         fontsize nFontSize + 2
         fontname cFontName
         value '1/'+ alltrim( str( hmg_len( aData ) ) )
      end label
      setproperty( 'main', cGridName, 'CHECKBOXENABLED', .t. )
      main.json.addpage( nTabPage, cTitle )
      main.json.addcontrol( cGridName, nTabPage, 40, 10 )
      main.json.addcontrol( cStatusName, nTabPage, 50 + ( nDesktopHeight - 350 ) , 10 )
      DoMethod( 'main', cGridName, 'DISABLEUPDATE' )
      for i := 1 to hmg_len( aHeaders )
         setproperty( 'main', cGridName, 'COLUMNDYNAMICFONT', i, { || if( getproperty( 'main', cGridName, 'CHECKBOXITEM', this.cellrowindex ),aBoldFont, nil ) } )
      next i         
      setproperty( 'main', cGridName, 'VALUE', { 1, 1 } )
      DoMethod( 'main', cGridName, 'ENABLEUPDATE' )
      for j := 1 to hmg_len( aHeaders )
         asize( aRowParents, 0 )
         cCol := aHeaders[ j ]
         do case
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#['
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtablerows( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         case hb_usubstr( aHeaders[ j ], 1, 2 ) == '#{'
            for i := 1 to getproperty( 'main', cGridName, 'ITEMCOUNT' )
               cValue := getproperty( 'main', cGridName, 'CELL', i , j )
               aadd( aRowParents, cValue )
            next i   
            showtableproperties( aclone( aRowParents ), cCol, val( alltrim( aRowParents[ 1 ] ) ) )
         endcase
      next j      
   endif      
return nil
   
    
function any2str( item )
   local cItem := ''
   local i 
   do case
   case valtype( item ) == 'C'
      return item
   case valtype( item ) == 'M'
      return item
   case valtype( item ) == 'D'
      return dtoc( item )
   case valtype( item ) == 'N'
      return alltrim( str( item ) )
   case valtype( item ) == 'L'
      return iif( item, 'Y', 'N' )
   case valtype( item ) == 'A'
      cItem := '{'
      for i := 1 to hmg_len( item )
         cItem := cItem + any2str( item[ i ] )
         if i < hmg_len( item )
            cItem := cItem + ', '
         endif
      next i
      cItem := cItem + '}'
      return cItem
   otherwise 
      return ''
   endcase
return nil    



function rightalignedtext( cData, nWidth, cFont, nSize, lBold )
   local hDC, BTstruct
   local nTextSize := 0
   local aTextData := {}
   local nType := BT_TEXT_OPAQUE
   nWidth := nWidth - 15
   hDC := BT_CreateDC ( , BT_HDC_DESKTOP, @BTstruct)
   if lBold
      nType := BT_TEXT_BOLD
   endif
   do while nTextSize < nWidth
      aTextData := BT_DrawTextSize ( hDC, cData, cFont, nSize, nType )
      nTextSize := aTextData[ 1 ]
      if nTextSize < nWidth
         cData := ' ' + cData
      endif
   enddo
   BT_DeleteDC (BTstruct)
   return cData
   

function cleantemp
   if file( GetTempFolder() + 'json_temp.sqlite' )
      ferase( GetTempFolder() + 'json_temp.sqlite' )
   endif   
return nil

function clearjson
      main.jsontext.value := ''
      main.json.release
      define tab json parent main at 230, 10 width nDesktopWidth - 20 height nDesktopHeight - 270 
      end tab
      asize( aTabPages, 0 )
return nil