#include <hmg.ch>

declare window main

function navigatehtmlstart
   local i := 0
   local cHTML := GetTempFolder() + 'json.html'
   local aItems := {}
   local aLine := {}
   local nColumns := 0
   local aData := {}
   private aColumns := {}
   if .not. iscontroldefined( table1, main )
      return nil
   endif
   if main.table1.itemcount == 0
      return nil
   endif
   oHTML := html_init( cHTML, 'JSON Viewer' )
   if oHTML == nil
      msgstop( 'HTML Creation Error!' )
      return nil
   endif
   asize( aColumns, 0 )
   && asize( aIsHeaders, hmg_len( aTabPages ) )
   && afill( aIsHeaders, .f. )
   // start from first tab
   nColumns := main.table1.columncount
   cColHead := main.table1.columnheader( 1 )
   do case 
   case cColHead == 'Ref.'
      // table
      cHeader := '$'
      findcolumns( '$', 2 )
      cData := columnshtml()
      cData := cData + showhtmltable( 0, aTabPages[ 1, 1 ] )
      fwrite( oHTML, cData )
   case cColHead == 'Parent Ref.' 
      // properties
      for i := 2 to nColumns
         cColumnHead := main.table1.columnheader( i ) 
         do case
         case hb_usubstr( cColumnHead, 1, 2 ) == '#[' // table
            cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
            findcolumns( cColumnHead, 2 )
            cData := columnshtml()
            cData := cData + showhtmltable( val( alltrim( main.table1.cell( 1, i ) ) ), cColumnHead, 2 )
         case hb_usubstr( cColumnHead, 1, 2 ) == '#{' // properties
            cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
            findcolumns( cColumnHead, 2 )
            cData := columnshtml()
            cData := cData + showhtmlproperties( val( alltrim( main.table1.cell( 1, i ) ) ), cColumnHead, 2 )
         otherwise
            cHeader := cColumnHead
            cData := main.table1.cell( 1, i )
         endcase
         fwrite( oHTML, '<p>' + cHeader + '</p><p>' + cData  + '</p>' )
      next i   
   endcase   
   html_close( oHTML )
   if file( cHTML )
//   html_viewer( cHTML )
      xlshtmlcopy( memoread( cHTML ) )
      ferase( cHTML )
   endif
return nil

function showhtmltable( nParent, cTitle, nStart )
   local i := 0
   local j := 0
   local nColCount := 0
   local nTabPage := 0
   local aTable := {}
   local aHeaders := {}
   local aJustify := {}
   local aWidths := {}
   local aLine := {}
   local aData := {}
   local aLineData := {}
   local cHTML := ''
   local nItemCount := 0
   local cColumnHead := ''
   local cHeader := ''
   local cData := ''
   local lColHeaders := .t.
   // find page number
   for i := nStart to hmg_len( aTabPages )
      if aTabPages[ i, 1 ] == cTitle
         nTabPage := i
         exit
      endif
   next i      
   if nTabPage == 0
      // tab not found!
      msgstop( 'Program Error 1!' )
      return cData
   endif
   nItemCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEMCOUNT' )
   nColCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNCOUNT' )
   for i := 3 to nColCount 
      aadd( aHeaders, getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNHEADER', i ) )
      aadd( aJustify, getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNJUSTIFY', i ) )
      aadd( aWidths, 100 )
   next i   
   for i := 1 to nItemCount
      aLine := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEM', i )
      asize( aLinedata, 0 )   
      if val( alltrim( aLine[ 2 ] ) ) == nParent
         for j := 3 to nColCount
            cColumnHead := aHeaders[ j - 2 ]
            do case
            case hb_usubstr( cColumnHead, 1, 2 ) == '#[' // table
               cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
               cData := showhtmltable( val( alltrim( aLine[ j ] ) ), cColumnHead, nTabPage + 1 )
            case hb_usubstr( cColumnHead, 1, 2 ) == '#{' // properties
               cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
               cData := showhtmlproperties( val( alltrim( aLine[ j ] ) ), cColumnHead, nTabPage + 1 )
            otherwise
               cData := aLine[ j ]
            endcase
            aadd( aLineData, cData )
         next j
         aadd( aData, aclone( aLineData ) )     
      endif   
   next i
   cHTML :=  html_table( cTitle, aData, aHeaders, aWidths, aJustify, , .f. ) 
return cHTML

function showhtmlproperties( nParent, cTitle, nStart )
   local i := 0
   local j := 0
   local nColCount := 0
   local nTabPage := 0
   local aTable := {}
   local aHeaders := {}
   local aJustify := {}
   local aWidths := {}
   local aLine := {}
   local aData := {}
   local aLineData := {}
   local cHTML := ''
   local nItemCount := 0
   local cColumnHead := ''
   local cHeader := ''
   local cData := ''
   local lColHeaders := .t.
   // find page number
   for i := nStart to hmg_len( aTabPages )
      if aTabPages[ i, 1 ] == cTitle
         nTabPage := i
         exit
      endif
   next i      
   if nTabPage == 0
      // tab not found!
      msgstop( 'Program Error 2!' )
      return cData
   endif
   
   nItemCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEMCOUNT' )
   nColCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNCOUNT' )
   for i := 2 to nColCount 
      aadd( aHeaders, getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNHEADER', i ) )
      aadd( aJustify, getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNJUSTIFY', i ) )
      aadd( aWidths, 100 )
   next i   
   for i := 1 to nItemCount
      aLine := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEM', i )
      asize( aLinedata, 0 )   
      if val( alltrim( aLine[ 1 ] ) ) == nParent
         for j := 2 to nColCount
            cColumnHead := aHeaders[ j - 1 ]
            do case
            case hb_usubstr( cColumnHead, 1, 2 ) == '#[' // table
               cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
               cData := showhtmltable( val( alltrim( aLine[ j ] ) ), cColumnHead, nTabPage + 1 )
            case hb_usubstr( cColumnHead, 1, 2 ) == '#{' // properties
               cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
               cData := showhtmlproperties( val( alltrim( aLine[ j ] ) ), cColumnHead, nTabPage + 1 )
            otherwise
               cData := aLine[ j ]
            endcase
            aadd( aLineData, cData )
         next j
         aadd( aData, aclone( aLineData ) )     
      endif   
   next i
   cHTML :=  html_table( cTitle, aData, aHeaders, aWidths, aJustify, , .f. ) 
return cHTML

function findcolumns( cHead, nStart )
   local i := 0
   local j := 0
   local nColCount := 0
   local cColumn := ''
   local nTabPage := 0
   asize( aColumns, 0 )
   for i := nStart to hmg_len( aTabPages )
      if aTabPages[ i, 1 ] == cHead 
         nTabPage := i
         exit
      endif
   next i
   if nTabPage == 0
      msgstop( 'Program Error 4!' )
      return nil
   endif
   nColCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNCOUNT' )
   for j := 1 to nColCount
      cColumn := getproperty( 'main', 'table'+ alltrim( str( nTabPage ) ), 'COLUMNHEADER', j )
      do case
      case cColumn == 'Ref.'
      case cColumn == 'Parent Ref.' 
      case hb_usubstr( cColumn, 1, 2 ) == '#[' // table
         addtablecolumnhead( cColumn, 2 )
      case hb_usubstr( cColumn, 1, 2 ) == '#{' // properties
         addtablecolumnhead( cColumn, 2 )
      otherwise
         aadd( aColumns, cColumn )
      endcase
   next j
return nil

function addtablecolumnhead( cTitle, nStart )
   local nTabPage := 0
   local i := 0
   local j := 0
   local nColCount := 0
   local cColumn := 0
   for i := nStart to hmg_len( aTabPages )
      if aTabPages[ i, 1 ] == cTitle
         nTabPage := i
         exit
      endif
   next i
   if nTabPage == 0
      msgstop( 'Program Error 3!' )
      return nil
   endif
   nColCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNCOUNT' )
   for j := 1 to nColCount
      cColumn := getproperty( 'main', 'table'+ alltrim( str( nTabPage ) ), 'COLUMNHEADER', j )
      do case
      case cColumn == 'Ref.'
      case cColumn == 'Parent Ref.' 
      case hb_usubstr( cColumn, 1, 2 ) == '#[' // table
         addtablecolumnhead( cColumn, nTabPage + 1 )
      case hb_usubstr( cColumn, 1, 2 ) == '#{' // properties
         addtablecolumnhead( cColumn, nTabPage + 1 )
      otherwise
         aadd( aColumns, cColumn )
      endcase
   next j
return nil

function columnshtml
   local cHTML := ''
   local i := 0
   cHTML := cHTML + '<TABLE Width="' + alltrim( str( hmg_len( aColumns ) * 100 ) ) + '">' + CRLF + '<TR>' + CRLF
   for i := 1 to hmg_len( aColumns )
      cAlign := 'CENTER'
      cHTML := cHTML + '<TD WIDTH=' + alltrim( str( 100 ) ) + ' ALIGN="' + cAlign + '" border-width=0><B>' + aColumns[ i ] + '</B></TD>' + CRLF
   next i
   cHTML := cHTML + '</TR>' + CRLF
   cHTML := cHTML + '</Table>'
   return cHTML
