#include <hmg.ch>

declare window main

function exporttables
   local i := 0, j := 0, k := 0
   local cFileName := ''
   Local oExcel,  oSheet, oBook   
   local nRow := 0
   local cSheetName := ''
   local aSheets := {}
   cFileName :=  PutFile( { { 'Excel Files (*.xlsx)', '*.xlsx' }, { 'All Files (*.*)', '*.*' } }, 'Save as Excel File...' )
   if hmg_len( cFileName ) > 0
      if .not. hmg_upper( hb_usubstr( cFileName, hmg_len( cFileName ) - 4, 5 ) ) == '.XLSX'
         cFileName := cFileName + '.xlsx'   
      endif
      if file( cFileName )
         if msgyesno( 'File Exists! Do you want to overwrite?' )
            ferase( cFileName )
         else
            return nil         
         endif   
      endif   
   else
      return nil   
   endif      
   oExcel := win_oleCreateObject( "Excel.Application" )
   if oExcel == NIL
      MsgStop({"Error: "+win_oleErrorText()})
      RETURN NIL
   endif
   oExcel:Visible := .F.
   oExcel:WorkBooks:Add()
   for i := hmg_len( aTabPages ) to 1 step - 1
      oExcel:sheets:add()
      oSheet := oExcel:ActiveSheet()
      cSheetName := strtran( aTabPages[ i, 1 ], '$', 'Root' )
      cSheetName := strtran( cSheetName, '#[', '' )
      cSheetName := strtran( cSheetName, '#{', '' )
      cSheetName := strtran( cSheetName, ']', '' )
      cSheetName := strtran( cSheetName, '}', '' )
      cSheetName := alltrim( str( i ) ) + '_' + cSheetName
      if hmg_len( cSheetName ) > 30
         cSheetName := hb_usubstr( cSheetName, 1, 30 )
      endif   
      oSheet:Name := cSheetName
      cGridName := 'table' + alltrim( str( i ) )
      nItemCount := getproperty( 'main', cGridName, 'ITEMCOUNT' )
      nColCount := getproperty( 'main', cGridName, 'COLUMNCOUNT' )
      nRow := 1 
      for j := 1 to nColCount
         oSheet:Cells(nRow, j):Value := getproperty( 'main', cGridName, 'COLUMNHEADER', j )
         oSheet:Cells(nRow, j):Font:Bold:=.T. 
         oSheet:Cells(nRow, j):Borders:Color:= RGB( 0, 0, 0 )
         oSheet:Cells(nRow, j):Borders:Weight:= 2           
      next j
      for j := 1 to nItemCount
         nRow++
         aLineData := getproperty( 'main', cGridName, 'ITEM', j )      
         for k := 1 to hmg_len( aLineData )
            cColHead := getproperty( 'main', cGridName, 'COLUMNHEADER', k )
            oSheet:Cells(nRow, k):Value := aLineData[ k ]
            oSheet:Cells(nRow, k):Borders:Color:= RGB( 0, 0, 0 )
            oSheet:Cells(nRow, k):Borders:Weight:= 2
            do case 
            case hb_usubstr( cColHead, 1, 2 ) == "#["
               //table
               oSheet:Cells(nRow, k):Interior:Color := RGB( aColorTable[ 1 ], aColorTable[ 2 ], aColorTable[ 3 ] )
            case hb_usubstr( cColHead, 1, 2 ) == "#{"  
               oSheet:Cells(nRow, k):Interior:Color := RGB( aColorProperties[ 1 ], aColorProperties[ 2 ], aColorProperties[ 3 ] )
               // prop
            endcase
         next k
      next j      
      for j := 1 to nColCount
         oSheet:Columns( j ):AutoFit()
      next j   
   next i
   oBook := oExcel:ActiveWorkBook()   
   oBook:SaveAs( cFileName )
   oExcel:DisplayAlerts = .t.
   oExcel:Quit()
   ShellExecute( "Open", 0, cFileName )
return nil   

function xlshtmlcopy( cHTML )
   local i := 0, j := 0, k := 0
   local cFileName := ''
   Local oExcel,  oSheet, oBook   
   local nRow := 0
   local cSheetName := ''
   local nRows := 0
   local nCols := 0
   cFileName :=  PutFile( { { 'Excel Files (*.xlsx)', '*.xlsx' }, { 'All Files (*.*)', '*.*' } }, 'Save as Excel File...' )
   if hmg_len( cFileName ) > 0
      if .not. hmg_upper( hb_usubstr( cFileName, hmg_len( cFileName ) - 4, 5 ) ) == '.XLSX'
         cFileName := cFileName + '.xlsx'   
      endif
      if file( cFileName )
         if msgyesno( 'File Exists! Do you want to overwrite?' )
            ferase( cFileName )
         else
            return nil         
         endif   
      endif   
   else
      return nil   
   endif      
   oExcel := win_oleCreateObject( "Excel.Application" )
   if oExcel == NIL
      MsgStop({"Error: "+win_oleErrorText()})
      RETURN NIL
   endif
   oExcel:Visible := .F.
   oExcel:WorkBooks:Add()
   oSheet := oExcel:ActiveSheet()
   system.clipboard := cHTML
   oSheet:Paste()
   nRows := oSheet:UsedRange:Rows:Count()
   nCols := oSheet:UsedRange:Columns:Count()
   for i := 1 to nRows
      for j := 1 to nCols
         oSheet:Cells( i , j ):wrapText := .f.
      next j
   next i      
//   msginfo( str( nRows ) + ' Rows and ' + str( nCols ) + 'Cols' )
   for j := 1 to nCols
      oSheet:Columns( j ):AutoFit()
   next j   
   for j := 1 to nRows
      oSheet:Rows( j ):AutoFit()
   next j   
   oBook := oExcel:ActiveWorkBook()   
   oBook:SaveAs( cFileName )
   oExcel:DisplayAlerts = .t.
   oExcel:Quit()
   ShellExecute( "Open", 0, cFileName )
return nil