#include <hmg.ch>

declare window main

function exporttablesxml
   local i := 0
   local cFileName := ''
   local aItems := {}
   local aLine := {}
   local nColumns := 0
   local aData := {}
   private aColumns := {}
   if .not. iscontroldefined( table1, main )
      return nil
   endif
   if main.table1.itemcount == 0
      return nil
   endif
   cFileName :=  PutFile( { { 'XML Files (*.xml)', '*.xml' }, { 'All Files (*.*)', '*.*' } }, 'Save as XML File...' )
   if hmg_len( cFileName ) > 0
      if .not. hmg_upper( hb_usubstr( cFileName, hmg_len( cFileName ) - 3, 4 ) ) == '.XML'
         cFileName := cFileName + '.xml'   
      endif
      if file( cFileName )
         if msgyesno( 'File Exists! Do you want to overwrite?' )
            ferase( cFileName )
         else
            return nil         
         endif   
      endif   
   else
      return nil   
   endif      
   oFile := fcreate( cFileName )
   if oFile < 0
      msgstop( "File "+ cFileName + " could not be created!" )
      return nil
   endif
   // xml init
   fwrite( oFile, '<xml>' + CRLF )
   asize( aColumns, 0 )
   && asize( aIsHeaders, hmg_len( aTabPages ) )
   && afill( aIsHeaders, .f. )
   // start from first tab
   nColumns := main.table1.columncount
   cColHead := main.table1.columnheader( 1 )
   do case 
   case cColHead == 'Ref.'
      // table
      cHeader := '$'
      findxmlcolumns( '$', 2 )
      cData := '<table>' + showxmltable( 0, aTabPages[ 1, 1 ] ) + '</table>'
      fwrite( oFile, cData )
   case cColHead == 'Parent Ref.' 
      // properties
      for i := 2 to nColumns
         cColumnHead := main.table1.columnheader( i ) 
         do case
         case hb_usubstr( cColumnHead, 1, 2 ) == '#[' // table
            cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
            findxmlcolumns( cColumnHead, 2 )
            cData := showxmltable( val( alltrim( main.table1.cell( 1, i ) ) ), cColumnHead, 2, cHeader )
         case hb_usubstr( cColumnHead, 1, 2 ) == '#{' // properties
            cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
            findxmlcolumns( cColumnHead, 2 )
            cData := showxmlproperties( val( alltrim( main.table1.cell( 1, i ) ) ), cColumnHead, 2, cHeader )
         otherwise
            cHeader := cColumnHead
            cData := '<' + cHeader + '>' + main.table1.cell( 1, i ) + '</' + cHeader + '>'
         endcase
         fwrite( oFile, cData )
      next i   
   endcase   
   fwrite( oFile, '</xml>' )
   fclose( oFile )
   msginfo( cFilename + ' is created successfully!' )
   if msgyesno( 'Do you want to open this XML Data file using Excel?' )
      oExcel := win_oleCreateObject( "Excel.Application" )
      if oExcel == NIL
         MsgStop({"Error: "+win_oleErrorText()})
         RETURN NIL
      endif
      oExcel:Visible := .T.
      oBook := oExcel:WorkBooks
      oBook:OpenXML( cFileName )
   endif   
return nil

function showxmltable( nParent, cTitle, nStart, cXMLTag )
   local i := 0
   local j := 0
   local nColCount := 0
   local nTabPage := 0
   local aTable := {}
   local aHeaders := {}
   local aJustify := {}
   local aWidths := {}
   local aLine := {}
   local aData := {}
   local aLineData := {}
   local cHTML := ''
   local nItemCount := 0
   local cColumnHead := ''
   local cHeader := ''
   local cData := ''
   local lColHeaders := .t.
   // find page number
   for i := nStart to hmg_len( aTabPages )
      if aTabPages[ i, 1 ] == cTitle
         nTabPage := i
         exit
      endif
   next i      
   if nTabPage == 0
      // tab not found!
      msgstop( 'Program Error 1!' )
      return cData
   endif
   nItemCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEMCOUNT' )
   nColCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNCOUNT' )
   for i := 3 to nColCount 
      aadd( aHeaders, getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNHEADER', i ) )
      aadd( aJustify, getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNJUSTIFY', i ) )
      aadd( aWidths, 100 )
   next i   
   for i := 1 to nItemCount
      aLine := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEM', i )
      asize( aLinedata, 0 )   
      if val( alltrim( aLine[ 2 ] ) ) == nParent
         for j := 3 to nColCount
            cColumnHead := aHeaders[ j - 2 ]
            do case
            case hb_usubstr( cColumnHead, 1, 2 ) == '#[' // table
               cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
               cData := showxmltable( val( alltrim( aLine[ j ] ) ), cColumnHead, nTabPage + 1, cHeader )
            case hb_usubstr( cColumnHead, 1, 2 ) == '#{' // properties
               cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
               cData := showxmlproperties( val( alltrim( aLine[ j ] ) ), cColumnHead, nTabPage + 1, cHeader )
            otherwise
               cData := aLine[ j ]
            endcase
            aadd( aLineData, cData )
         next j
         aadd( aData, aclone( aLineData ) )     
      endif   
   next i
   cHTML :=  xml_table( cXMLTag, aData, aHeaders, aWidths, aJustify, , .f. ) 
return cHTML

function showxmlproperties( nParent, cTitle, nStart, cXMLTag )
   local i := 0
   local j := 0
   local nColCount := 0
   local nTabPage := 0
   local aTable := {}
   local aHeaders := {}
   local aJustify := {}
   local aWidths := {}
   local aLine := {}
   local aData := {}
   local aLineData := {}
   local cHTML := ''
   local nItemCount := 0
   local cColumnHead := ''
   local cHeader := ''
   local cData := ''
   local lColHeaders := .t.
   // find page number
   for i := nStart to hmg_len( aTabPages )
      if aTabPages[ i, 1 ] == cTitle
         nTabPage := i
         exit
      endif
   next i      
   if nTabPage == 0
      // tab not found!
      msgstop( 'Program Error 2!' )
      return cData
   endif
   
   nItemCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEMCOUNT' )
   nColCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNCOUNT' )
   for i := 2 to nColCount 
      aadd( aHeaders, getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNHEADER', i ) )
      aadd( aJustify, getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNJUSTIFY', i ) )
      aadd( aWidths, 100 )
   next i   
   for i := 1 to nItemCount
      aLine := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'ITEM', i )
      asize( aLinedata, 0 )   
      if val( alltrim( aLine[ 1 ] ) ) == nParent
         for j := 2 to nColCount
            cColumnHead := aHeaders[ j - 1 ]
            do case
            case hb_usubstr( cColumnHead, 1, 2 ) == '#[' // table
               cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
               cData := showxmltable( val( alltrim( aLine[ j ] ) ), cColumnHead, nTabPage + 1, cHeader )
            case hb_usubstr( cColumnHead, 1, 2 ) == '#{' // properties
               cHeader := hb_usubstr( cColumnHead, 3, hmg_len( cColumnHead ) - 3 )
               cData := showxmlproperties( val( alltrim( aLine[ j ] ) ), cColumnHead, nTabPage + 1, cHeader )
            otherwise
               cData := aLine[ j ]
            endcase
            aadd( aLineData, cData )
         next j
         aadd( aData, aclone( aLineData ) )     
      endif   
   next i
   cHTML :=  xml_table( cXMLTag, aData, aHeaders, aWidths, aJustify, , .f. ) 
return cHTML


function xml_table( cHeader, aTable, aColumnHeaders, aColumnWidths, aColumnJustify, aDataJustify, lColHeaders )
   local nTotalWidth := 0
   local cHTML := ''
   local nRows := 0
   local aLineData := {}
   local nColumnCount := 0
   local i := 0, j := 0
   local lDataJustify := .f.
   local cAlign := 'LEFT'
   
   default cHeader := ''
   default aColumnHeaders := {}
   default aColumnWidths := {}
   default aColumnJustify := {}
   default aDataJustify := {}
   if valtype( aTable ) == 'A'
      if hmg_len( aTable ) == 0
         return nil
      endif
   else   
      return nil
   endif
   if hmg_len( aDataJustify ) > 0
      lDataJustify := .t.
   endif
   nRows := hmg_len( aTable )
   nColumnCount := hmg_len( aColumnHeaders )
   for i := 1 to nColumnCount
      nTotalWidth := nTotalWidth + aColumnWidths[ i ] 
   next i
   
   // report headers table   
   && cHTML := cHTML + '<TABLE Width="' + alltrim( str( nTotalWidth ) ) + '">' + CRLF
   && if hmg_len( cHeader ) > 0
      && cHTML := cHTML + '<TR><TD align="CENTER" class="TD1"><font size=3><u>' + cHeader + '</u></font></TD></TR>' + CRLF
   && endif
   && cHTML := cHTML + '</TABLE>' + CRLF
   
   
   // Main Table
   // Column Headers
   
   // Now it is time for data
   
   for i := 1 to nRows
      aLineData := aTable[ i ]
      cHTML := cHTML + '<' + cHeader + '>' 
      for j := 1 to nColumnCount
         if aColumnWidths[ j ] > 0
            cAlign := if( aColumnJustify[ j ] == 1, 'RIGHT', if( aColumnJustify[ j ] == 2, 'CENTER', 'LEFT' ) )
            if lDataJustify
               cAlign := if( aDataJustify[ i, j ] == 1, 'RIGHT', if( aDataJustify[ i, j ] == 2, 'CENTER', 'LEFT' ) )
            endif      
            if valtype( aLineData[ j ] ) == 'U'
               aLineData[ j ] := ''
            endif
            if hb_usubstr( aColumnHeaders[ j ], 1, 2 ) == '#[' .or. hb_usubstr( aColumnHeaders[ j ], 1, 2 ) == '#{' 
               cHTML := cHTML + aLineData[ j ] 
            else
               cHTML := cHTML + '<' + aColumnHeaders[ j ] + '>' + aLineData[ j ] + '</' + aColumnHeaders[ j ] + '>' 
            endif   
         endif
      next j
      cHTML := cHTML + '</' + cHeader + '>' 
   next i
   && fWrite( oFile, cHTML )   
   && html_para( oFile ) 
return cHTML

function findxmlcolumns( cHead, nStart )
   local i := 0
   local j := 0
   local nColCount := 0
   local cColumn := ''
   local nTabPage := 0
   asize( aColumns, 0 )
   for i := nStart to hmg_len( aTabPages )
      if aTabPages[ i, 1 ] == cHead 
         nTabPage := i
         exit
      endif
   next i
   if nTabPage == 0
      msgstop( 'Program Error 4!' )
      return nil
   endif
   nColCount := getproperty( 'main', 'table' + alltrim( str( nTabPage ) ), 'COLUMNCOUNT' )
   for j := 1 to nColCount
      cColumn := getproperty( 'main', 'table'+ alltrim( str( nTabPage ) ), 'COLUMNHEADER', j )
      do case
      case cColumn == 'Ref.'
      case cColumn == 'Parent Ref.' 
      case hb_usubstr( cColumn, 1, 2 ) == '#[' // table
         addtablecolumnhead( cColumn, 2 )
      case hb_usubstr( cColumn, 1, 2 ) == '#{' // properties
         addtablecolumnhead( cColumn, 2 )
      otherwise
         aadd( aColumns, cColumn )
      endcase
   next j
return nil
